////////////////////////////////////////////////
//               SHADERS
//
////////////////////////////////////////////////
//Loader shader program
//Report errrors
void setShaderProgram(GLuint * program, char * vertname,char * fragname)
{
char *vs,*fs;
*program = glCreateProgram();
GLint shaderstatus;
//Loading and compiling vertex shader	
          char path[100];
          strcpy(path,"shaders/");
          strcat(path,vertname);
		GLuint vertex_shader = glCreateShader(GL_VERTEX_SHADER);
		
	    vs = textFileRead(path);
		const char * vv = vs;
  		glShaderSource(vertex_shader, 1, &vv,NULL);
	    free(vs);
       	glCompileShader(vertex_shader);
		glAttachShader(*program,vertex_shader);
       glGetShaderiv(vertex_shader,GL_COMPILE_STATUS,&shaderstatus);
       if(shaderstatus != GL_TRUE)
       {
         glGetShaderInfoLog(vertex_shader,sizeof(errstring),NULL,errstring);
         MessageBox (NULL, (char*)errstring,"Vertex shader error", 0);
       }    
//Loading and compiling fragment shader
        GLuint fragment_shader = glCreateShader(GL_FRAGMENT_SHADER);
        strcpy(path,"shaders/");	
        strcat(path,fragname);
		fs = textFileRead(path);
		const char * ff = fs;
		glShaderSource(fragment_shader, 1, &ff,NULL);
        free(fs);
		glCompileShader(fragment_shader);
    	glAttachShader(*program,fragment_shader);
       glGetShaderiv(fragment_shader,GL_COMPILE_STATUS,&shaderstatus);
       if(shaderstatus != GL_TRUE)
       {
         glGetShaderInfoLog(fragment_shader,sizeof(errstring),NULL,errstring);
         MessageBox (NULL, (char*)errstring,"Fragment shader error", 0);
       }
		glLinkProgram(*program);
        glUseProgram(*program);
}

//Textfile reader function
char *textFileRead(char *fn) {


	FILE *fp;
	char *content = NULL;

	int count=0;

	if (fn != NULL) {
		fp = fopen(fn,"rt");

		if (fp != NULL) {
      
      fseek(fp, 0, SEEK_END);
      count = ftell(fp);
      rewind(fp);

			if (count > 0) {
				content = (char *)malloc(sizeof(char) * (count+1));
				count = fread(content,sizeof(char),count,fp);
				content[count] = '\0';
			}
			fclose(fp);
		}
	}
	return content;
}
